package se.pmws1213.diaballik;

import java.lang.reflect.Method;

import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Monitor;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.wb.swt.SWTResourceManager;

import se.pmws1213.DiaballikGame;
import se.pmws1213.Field;
import se.pmws1213.Player;
import se.pmws1213.StartField;
import se.pmws1213.diaballik.gui.DiaballikMainScreen;

public class Util
{

	public static Image getImage(final Field field)
	{
		String imagePath = toImagePath(field);
		Image image = null;
		String[] split = imagePath.split("\\|");
		if(split.length == 2)
		{
			Image baseImage = SWTResourceManager.getImage(DiaballikMainScreen.class, split[0]);
			Image decoration = SWTResourceManager.getImage(DiaballikMainScreen.class, split[1]);
			image = SWTResourceManager.decorateImage(baseImage, decoration);
		}
		else
		{
			image = SWTResourceManager.getImage(DiaballikMainScreen.class, split[0]);
		}
		return image;
	}

	public static String toImagePath(final Field field)
	{
		StringBuilder sb = new StringBuilder();
		String ball = "";

		if(field != null)
		{
			sb.append("/img/field");

			if(field.getHolder() != null)
			{
				String color = field.getHolder().getPlayer().getColor();
				sb.append(color);
				sb.append("Holder");

				if(field.getHolder().getBall() != null)
				{
					//ball
					ball = "|/img/ball"+ color + ".png";
				}
			}
			else
			{
				if(field instanceof StartField)
				{
					//startfield
					StartField startField = (StartField) field;
					String color = startField.getPlayer().getColor();
					sb.append("Start" + color);
				}
				else
				{
					//empty field
					sb.append("Empty");
				}
			}	  
		}
		sb.append(".png");
		sb.append(ball);

		return sb.toString();
	}

	public static Label findLabelForField(DiaballikMainScreen screen, Field field)
	{
		Label l = null;
		StringBuilder sb = new StringBuilder("getF");

		sb.append(field.getX());
		sb.append(field.getY());

		try
		{
			Method method = DiaballikMainScreen.class.getMethod(sb.toString());
			l = (Label) method.invoke(screen);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}

		return l;
	}

	public static void centerShell(Shell shell)
	{
		Display display = shell.getDisplay();
		Monitor primary = display.getPrimaryMonitor();
		Rectangle bounds = primary.getBounds();
		Rectangle rect = shell.getBounds();
		int x = bounds.x + (bounds.width - rect.width) / 2;
		int y = bounds.y + (bounds.height - rect.height) / 2;

		shell.setLocation(x, y);
	}

	public static Player findPlayer(String name, DiaballikGame game)
	{
		for(Player p : game.getPlayers())
		{
			if(name.equals(p.getName()))
			{
				return p;
			}
		}

		return null;
	}
}
