package se.pmws1213.diaballik.controller;

import java.beans.PropertyChangeEvent;

import org.eclipse.swt.widgets.Label;

import se.pmws1213.Action;
import se.pmws1213.Holder;
import se.pmws1213.Move;
import se.pmws1213.Player;
import se.pmws1213.diaballik.gui.DiaballikMainScreen;

public class PlayerController extends AbstractController
{

	Player player;
	Label instructionLabel;
	DiaballikMainScreen mainScreen;

	public PlayerController(DiaballikMainScreen mainScreen, Player player, Label instructionLabel)
	{
		this.player = player;
		this.instructionLabel = instructionLabel;
		this.mainScreen = mainScreen;
	}

	public void start()
	{
		for(Holder holder : player.getHolders())
		{
			HolderController hController = new HolderController(mainScreen, holder);
			hController.start();
		}

		super.start();

		propertyChange(null);
	}

	@Override
	public void propertyChange(PropertyChangeEvent arg0)
	{	
		if(player.getCurrentGame() != null)
		{
			refreshUI();
		}
	}

	@Override
	public void refreshUI()
	{
		if(player.getCurrentGame() != null)
		{

			int moves = 0;

			for(Action action : player.getActions())
			{
				if(action instanceof Move)
				{
					moves++;
				}
			}

			instructionLabel.setText("Actions left: " + moves + " move(s), " + (player.getActions().size() - moves) + " pass");
		}
	}

	@Override
	public void registerListeners()
	{
		listenTo(Player.PROPERTY_ACTIONS, player);
	}
}
